C====================================================================
C
C     Format aendern der Density Datei  Stand 8.3.96  format.f
C
C     ORIGINAL PROGRAMMED                BY M.SATO      88-02
C     ARRANGED FOR MEMTARO DATA          BY S.KUMAZAWA  89-08-11
C     MS-DOS VERSION                     BY S.KUMAZAWA  89-08-24
C     ADD 2 X 2 UNIT CELL MODE           BY S.KUMAZAWA  90-04-17
C     ADD PROJECTION & ORIGIN SHIFT MODE BY Y.KUBOTA    91-04-11
C     MODIFIED PROGRAM FOR MEED DATA     BY S.KUMAZAWA  91-10-31
C     BUG FIXED FOR TRANSVERSE ROUTINE   BY S.KUMAZAWA  91-11-08
C     BUG FIXED FOR AXIS NAMING          BY S.KUMAZAWA  91-11-15
C
C                             FACOM(NAGOYA)      PRO-FORTRAN
C     USING PLOTTER PEN  1 =  SOLID THIN LINE,   WHITE
C     ( ORIGINAL )       3 =  SOLID THICK LINE,  GREEN
C                        4 =  DOTTED THIN LINE,  BLUE
C
C====================================================================
C     - Ausgaberoutine angepasst fuer SURFER-Graphik:
C       Modifiziert von K. Burger und Dr. P. Schiebel, Mai 1994.
C     - Modifiziert fuer beliebig schiefe Zellen und Ausgabe fuer das
C       Programm SURFER fuer WINDOWS:          K. Burger 1995
C     - Mod. fuer 128x128x128 Pixel: Okt. 1995, kb.
C     - Mod. "bugs" entfernt Jan. 1996 (kb)
C====================================================================
C     Parameter Masym (Maximalzahl der Punkte in der asymmetrischen 
C     Einheit) und Mpix (Maximalzahl der Pixel entlang einer Achse)
C     muessen hier und in allen Unterroutinen angepasst werden!
C
      PROGRAM denformat
C
      IMPLICIT INTEGER*4 (I-N)
      PARAMETER (MASYM=275000,MPIX=129)
      PARAMETER (VPX1=0.0,VPY1=0.0,VPX2=1.6,VPY2=1.0)
      PARAMETER (WPX1=VPX1-0.05,WPY1=VPY1-0.2)
      PARAMETER (WPX2=VPX2-0.05,WPY2=VPY2-0.2)
      COMMON/DENS/DELC(0:MPIX,0:MPIX,0:MPIX),CELL(6),NPIX(3)
      COMMON/COOR/RDEO(MASYM),IASYM(3,MASYM),NASYM
      COMMON /CONST/TOTALE,RH,RK,RL,AS,BS,CS,GA,GB,GG,
     $              RDINT,FF1,FF2,POP,RTASYM,PI
      COMMON/SYMOP/IROT(3,3,48),ITRS(3,48),ISUB(3,4),NSYM,NCEN,NSUB
      COMMON/PARA/MAPT,NMX,NMY
      CHARACTER FILDEN*30,TITLE*200
      real*8 rsum,rsumalt
C
 1000 FORMAT(2(/' '))
 2000 FORMAT(BN,I3)
 2010 FORMAT(A30)
 3010 FORMAT(/' ==============================================='
     $      //'     Format.f -- Dichtedatei-Format aendern'
     $      //'     VERSION 3.22  COPYRIGHTS (C) S.KUMAZAWA'
     $      //'     Zuletzt modifiziert K. Burger  Maerz 1996'
     $      //' ==============================================='
     $      //' INPUT DENSITY FILE''S NAME    = ')
 3020 FORMAT( ' ARE YOU SURE ?  YES(0)/NO(1) = ')
C
C
C*** READ DENSITY FILE & RECONSTRUCT DENSITY ***
C
   10 WRITE(*,1000)
      WRITE(*,3010)
      READ(*,2010,ERR=10) FILDEN
      WRITE(*,3020)
      READ(*,2000,ERR=10) NYES
      IF(NYES.NE.0) GOTO 10
C
      OPEN(3,FILE=FILDEN,STATUS='OLD',ERR=10)
        READ(3,'(A200)') TITLE
        WRITE(*,'(A200)') TITLE
        READ(3,'(I7)')  NASYM
        IF (NASYM.GT.MASYM) CALL PROEND('DIMENSION OVER FOR IASYM.')

C       READ(3,'(2(3I5,F20.13))',END=30)
C    $      ((IASYM(J,I),J=1,3),RDEO(I),I=1,NASYM)

        if (mod(NASYM,2).eq.0) then
          do 991 i=1,NASYM/2
            READ(3,1090) (IASYM(J,2*I-1),J=1,3),RDEO(2*I-1),
     $       (IASYM(j,2*i),j=1,3),RDEO(2*i)
991	  continue
        else
          do 992 i=1,NASYM/2
            READ(3,1090) (IASYM(J,2*I-1),J=1,3),RDEO(2*I-1),
     $       (IASYM(j,2*i),j=1,3),RDEO(2*i)
992	  continue
          READ(3,1091) (IASYM(J,NASYM),J=1,3),RDEO(NASYM)
        endif
1090    format (2(3(I3,1x),F13.5))
1091    format (1(3(I3,1x),F13.5))
        print *,'Letzte Zeile :'
	print *,(IASYM(J,NASYM),J=1,3),RDEO(NASYM)
        READ(3,'(6F10.5)') (CELL(I),I=1,6)
        READ(3,'(6I5)') (NPIX(I),I=1,3),NSYM,NCEN,NSUB
        IF (NPIX(1).GT.MPIX.OR.NPIX(2).GT.MPIX.OR.NPIX(3).GT.MPIX)
     $     CALL PROEND('DIMENSION OVER FOR DENSITY ARRAY DELC.')
        READ(3,'(12I5)')
     $      (((IROT(I,J,K),I=1,3),J=1,3),(ITRS(I,K),I=1,3),K=1,NSYM)
        READ(3,'(3I5)') ((ISUB(I,K),I=1,3),K=1,NSUB)
      CLOSE(3)
C
C     SAVE DENSITY DATA

1092    format (2(3(I3,1x),F13.5,1X))
1093    format (6F10.5)
      OPEN(20,FILE=filden,FORM='FORMATTED',STATUS='UNKNOWN',
     $     ACCESS='SEQUENTIAL')
        WRITE(20,'(A200)') TITLE
        WRITE(20,'(I7)') NASYM
        WRITE(20,1092) ((IASYM(I,J),I=1,3),RDEO(J),J=1,NASYM)
        WRITE(20,1093) (CELL(I),I=1,6)
        WRITE(20,'(6I5)') (NPIX(I),I=1,3),NSYM,NCEN,NSUB
        WRITE(20,'(12I5)')
     $  (((IROT(I,J,K),I=1,3),J=1,3),(ITRS(I,K),I=1,3),K=1,NSYM)
        WRITE(20,'(3I5)') ((ISUB(I,K),I=1,3),K=1,NSUB)
      CLOSE(20)
C
      STOP
      END
C
C--------------------------------------------------------------------
C     TERMINATE PROGRAM BECAUSE ERROR OCCURED.
C--------------------------------------------------------------------
C
      SUBROUTINE PROEND(MESS)
C
      CHARACTER*(*) MESS
C
 3000 FORMAT(//' !!! ERROR !!! : ',A)
C
      WRITE(*,3000) MESS
C
      RETURN
      END
C
C  ============================================================
C
