C--------------------------------------------------------------------
C     MAKE ASYMMETRIC UNIT CELL COORDINATE. ( PIXEL UNIT )
C     AND PHASE FACTOR TABLES
C--------------------------------------------------------------------
C
      SUBROUTINE MKASY2(masym,nasym,mpix,NPIX,
     $  IROT,RTRS,RSUB,nsym,ncen,nsub,RDEN,rdint,IASYM,IDE)
C
C     *** ncen = 0/1 for no/a center of inversion present in the cell
C     *** nsym = number of symetry operators (1<=nsym<=48)
C     *** nsub = number of sub-translations in the cell because of 
C     ***        a non-primitive Bravais lattice: I,A,B,C,F,R (1<=nsub<=4)
C     *** IROT() = array of all symmetry operators' rotation matrices
C     *** RTRS() = array of corresponding translation vectors
C     *** RSUB() = transl. vectors belonging to cell-sub-translations
C
      implicit none
      integer*4 nasym,masym
C     *** density array ***
      real*8 RDEN(masym),rdint
C     *** pixels along a,b,c axis; ia,ib,ic of pixels in asymm. unit ***
      integer NPIX(3),IASYM(3,masym),mpix
C     *** symmetry operators ***
      integer nsym,ncen,nsub
      integer IROT(3,3,48)
      real*8  RTRS(3,48),RSUB(3,4)
C     *** auxilary array ***
      integer IDE(0:mpix,0:mpix,0:mpix)
C     *** the rest ***
      integer kx,ky,kz,nx,ny,nz,ic,it,is
      real*8 x,y,z,rx,ry,rz
      
C
C*** MAKE ASYMMETRIC UNIT COODINATE ***
C
      print *,'Calculating asymmetric unit pixels'
      nasym=0
      DO 10 kz=0,NPIX(3)-1
      DO 10 ky=0,NPIX(2)-1
      DO 10 kx=0,NPIX(1)-1
      IF (IDE(kx,ky,kz).GT.-1) THEN
	x=kx/DFLOAT(npix(1))
	y=ky/DFLOAT(npix(2))
	z=kz/DFLOAT(npix(3))
        DO 20 ic=1,ncen+1
        DO 20 it=1,nsub
        DO 20 is=1,nsym
        rx=IROT(1,1,is)*x+IROT(1,2,is)*y+IROT(1,3,is)*z+RTRS(1,is)
        ry=IROT(2,1,is)*x+IROT(2,2,is)*y+IROT(2,3,is)*z+RTRS(2,is)
        rz=IROT(3,1,is)*x+IROT(3,2,is)*y+IROT(3,3,is)*z+RTRS(3,is)
        IF (ic.EQ.2) THEN
          nx=NINT( DMOD(2-rx+RSUB(1,it),1d0)*NPIX(1) )
          ny=NINT( DMOD(2-ry+RSUB(2,it),1d0)*NPIX(2) )
          nz=NINT( DMOD(2-rz+RSUB(3,it),1d0)*NPIX(3) )
	ELSE
          nx=NINT( DMOD(2+rx+RSUB(1,it),1d0)*NPIX(1) )
          ny=NINT( DMOD(2+ry+RSUB(2,it),1d0)*NPIX(2) )
          nz=NINT( DMOD(2+rz+RSUB(3,it),1d0)*NPIX(3) )
        END IF
        IF (kx.NE.nx.OR.ky.NE.ny.OR.kz.NE.nz) IDE(nx,ny,nz)=-1
   20   CONTINUE
        nasym=nasym+1
        IF (nasym.GT.MASYM) CALL PROEND(
     $   'DIMENSION OVER FOR MKASYM - TOO MANY POINTS IN ASYM. UNIT')
        RDEN(nasym)=rdint
        IASYM(1,nasym)=kx
        IASYM(2,nasym)=ky
        IASYM(3,nasym)=kz
      END IF
   10 CONTINUE
      RETURN
      END
