C     *** create GRID-file (with perpendicular axes and equal spacing)
C     *** for the PC-program SURFER (Windows-version)
C
      SUBROUTINE SURFGRID(iskal,vx,vy,mpix,lx,ly,D,dmin,dmax)
C
C     *** iskal= 0/1 for yes/no scaling the axes with the cell-constants
C     *** vx,vy= cell-constants for this map x and y
C     *** lx,ly= number of pixels along map x and y (with edges)
C     *** D(1..lx,1..ly) density map
C     *** dmin/dmax minimum and maximum of density
C
      implicit integer (i-n)
      implicit real*8 (a-h,o-z)
      dimension D(2*mpix+1,2*mpix+1)
      character*50 name
C
800   name='bild.grd'
      write(*,8001) name(1:8)
8001  format(' Name for SURFER GRID-file (default=', a ,') ', $)
      read(*,'(A50)') name
      if (name(1:9).eq.'         ') name='bild.grd'
      write(*,*) 'Output to file ',name
      open(7,file=name,status='unknown',err=800)

      write(7,'(a4)') 'DSAA'
      write(7,'(I3,1X,I3)') lx,ly
      if (iskal.eq.0) then
C       * with scaling
        write(7,'(a4,1x,f10.5)') '   0',vx
        write(7,'(a4,1x,f10.5)') '   0',vy
      else
C       *  without scaling
        write(7,*) '   0   1'
        write(7,*) '   0   1'
      endif
      write(7,'(f15.3,1x,f15.3)') Dmin,Dmax 
C     *** write density ***       
      do 100 iy=1,ly
C        write(7,'(3(f16.6,1x))')(D(ix,iy), ix=1,lx)
         write(7,*)(sngl(D(ix,iy)), ix=1,lx)
  100 continue

      close(7)
      return
      end
